<id>
Pie Chart Mod
</id>

<version>
1.21
</version>

<mod info>
This little mod will allow your users to view the results of a poll as a piechart by clicking a link which will open the results in a window. Note this won't work all that well on polls with more than 16 results

To install you must put the font file in the root board directory!

</mod info>

<author>
Matthew Wolf (a.k.a Grudge)
</author>

<homepage>
www.mymods.co.uk
</homepage>

<edit file>
index.php
</edit file>

<search for>
		'pm' => array('InstantMessage.php', 'MessageMain'),
</search for>

<add after>
		'pie' => array('Subs-Graphics.php', 'PieChart'),
</add after>

<edit file>
$sourcedir/Subs-Graphics.php
</edit file>

<search for>
	function loaded()
	{
		return $this->m_bLoaded;
	}
}
</search for>

<add after>
function PieChart()
{
	global $context, $user_info, $db_prefix, $boarddir;
	
	$context['template_layers'] = array();

	$img = imagecreate(500, 250);

	// Background colour
	imagecolorallocate($img, 255, 255, 255);
	
	if (!isset($_REQUEST['poll']))
		exit;
	$pollID = $_REQUEST['poll'];
	// Get the question
	$request = db_query("
		SELECT
			p.question, p.hideResults, p.expireTime, p.maxVotes,
			COUNT(DISTINCT lp.ID_MEMBER) AS total
		FROM {$db_prefix}polls AS p
			LEFT JOIN {$db_prefix}log_polls AS lp ON (lp.ID_POLL = p.ID_POLL)
		WHERE p.ID_POLL = $pollID
		GROUP BY p.ID_POLL
		LIMIT 1", __FILE__, __LINE__);
	$pollinfo = mysql_fetch_assoc($request);
	mysql_free_result($request);

	// Get all the options.
	$request = db_query("
		SELECT ID_CHOICE, label, votes
		FROM {$db_prefix}poll_choices
		WHERE ID_POLL = $pollID", __FILE__, __LINE__);
	$pollOptions = array();
	$realtotal = 0;
	while ($row = mysql_fetch_assoc($request))
	{
		$pollOptions[$row['ID_CHOICE']] = array($row['label'], $row['votes']);
		$realtotal += $row['votes'];
	}
	mysql_free_result($request);

	// Only allow viewing if... you can view it ;).
	if ($pollinfo['hideResults'] == 1 && !allowedTo('moderate_board'))
		$context['allow_poll_view'] = false;
	elseif ($pollinfo['hideResults'] == 2 && !allowedTo('moderate_board'))
		$context['allow_poll_view'] = empty($pollinfo['expireTime']) || $pollinfo['expireTime'] <= time();
	else
		$context['allow_poll_view'] = true;
	if (!$context['allow_poll_view'])
		exit;

	// Calculate the percentages and bar lengths...
	$divisor = $realtotal == 0 ? 1 : $realtotal;

	// Determine if a decimal point is needed in order for the options to add to 100%.
	$precision = $realtotal == 100 ? 0 : 1;

	$currentDegree = 0;
	$boxNumber = 0;
	foreach ($pollOptions as $i => $option)
	{
		$chunk = floor(($option[1] * 360) / $divisor);
		$percent = floor(($option[1] * 100) / $divisor);
		$context['options'][$i] = array(
			'percent' => round($chunk, $precision),
			'votes' => $option[1],
			'label' => substr($option[0], 0, 15) . '(' . round($percent, 0) . '%)',
			'color' => imagecolorallocate($img, rand(0, 255), rand(0, 255), rand(0, 255)),
			'startdeg' => $currentDegree,
			'enddeg' => $currentDegree + $chunk,
			'boxxpos' => 210 + ($boxNumber > 7 ? 150 : 0),
			'boxypos' => 25 + (($boxNumber % 8) * 20)
		);
		$currentDegree += $chunk;
		$boxNumber++;
	}

	// allocate border colours
	$black = imagecolorallocate($img, 0, 0, 0);

	// Draw question
	Imagettftext($img, 10,0,10,12,$black,$boarddir . '/trebuc.ttf',$pollinfo['question']);

	// draw outlines
	foreach ($context['options'] as $id => $option)
	{
		imagefilledarc($img, 100, 115, 190, 190, $option['startdeg'], $option['enddeg'], $option['color'], IMG_ARC_PIE);
		imagefilledarc($img, 100, 115, 190, 190, $option['startdeg'], $option['enddeg'], $black, IMG_ARC_NOFILL | IMG_ARC_EDGED);
		imagefilledrectangle( $img, $option['boxxpos'], $option['boxypos'], $option['boxxpos'] + 10, $option['boxypos'] + 10, $option['color']);
		imagerectangle( $img, $option['boxxpos'], $option['boxypos'], $option['boxxpos'] + 10, $option['boxypos'] + 10, $black);
		Imagettftext($img, 10,0,$option['boxxpos'] + 15,$option['boxypos'] + 10,$black,$boarddir . '/trebuc.ttf',$option['label']);
	}

	// output image in the browser
	header("Content-type: image/png");
	imagepng($img);

	// free memory
	imagedestroy($img);
	
	obExit(false);
}
</add after>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
			// If they're allowed to lock the poll, show a link!
			if ($context['poll']['lock'])
				echo '
						<a href="', $scripturl, '?action=lockVoting;topic=', $context['current_topic'], '.', $context['start'], ';sesc=', $context['session_id'], '">', !$context['poll']['is_locked'] ? $txt['smf30'] : $txt['smf30b'], '</a><br />';
</search for>

<add before>
				echo '
						<a href="', $scripturl, '?action=pie;poll=', $context['poll']['id'], '" target="_blank" onclick="return reqWin(this.href, 550, 290);">', $txt['pie_chart_show'], '</a><br />';
</add before>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
$txt['pie_chart_show'] = 'Show Pie Chart';
</add before>